<?php
if ( !defined('IN_PHPBB') )
{
	die('Hacking attempt');
}

class dice_bbcode
{
	function display()
	{
		global $template, $config;


		$template->assign_vars(array(
		'L_BBCODE_D_HELP' => $template->lang('bbcode_d_help'),
		));
	}

	function prepare_template(&$bbcode_tpl)
	{
		global $user;
		// --------------------------------
		// DICE MOD CODE
		// --------------------------------

		$bbcode_tpl['dice_open2'] = str_replace('{ROLLED}', $user->lang('Dice_Mod_Rolled') . " - \\1", $bbcode_tpl['dice_open']);
		$bbcode_tpl['dice_open'] = str_replace('{ROLLED}', $user->lang('Dice_Mod_Rolled'), $bbcode_tpl['dice_open']);

		// --------------------------------
		// END DICE MOD CODE
		// --------------------------------
	}

	function load_template(&$tpl)
	{
		global $template;

		$tpl_filename = $template->make_filename('dice_bbcode.tpl');
		$tpl .= fread(fopen($tpl_filename, 'r'), filesize($tpl_filename));
	}

	function second_pass(&$text, &$uid)
	{
		global $config;

		$bbcode_tpl = &$config->globals['bbcode']->bbcode_tpl;

		// --------------------------------
		// BEGIN DICE MOD CODE
		// --------------------------------
		include_once($config->url('includes/dice_bbcode/function_dice_bbcode'));
		// [dice] tags for rolling dice
		$text = bbencode_second_pass_pda($text, "/\[dice:$uid\]/is", "[/dice:$uid]", 'replace_dice_results', $bbcode_tpl['dice_open'], $bbcode_tpl['dice_close'] );
		$text = preg_replace("/\[dice:$uid=(?:\"?([^\"]*)\"?)\]/si",  $bbcode_tpl['dice_open2'] . "[dice:$uid=\"\\1\"]", $text);
		$text = bbencode_second_pass_pda($text, "/\[dice:$uid=(\\\".*\\\")\]/is", "[/dice:$uid]", 'replace_dice_results', '', $bbcode_tpl['dice_close']);

		// --------------------------------
		// END DICE MOD CODE
		// --------------------------------
	}

	function first_pass(&$text, &$uid)
	{

		// --------------------------------
		// BEGIN DICE MOD CODE
		// --------------------------------

		$occurances = preg_match_all("#\[dice\]([-\s\w+/*]*?)\[/dice\]#i", $text, $temp);

		//list($usec,$sec)=explode(" ",microtime());
		mt_srand((double)microtime()*1000000);//$sec * $usec);

		// Loop to fix randomness problem of results when multiple die rolls are made in a single post - Hades
		for($i=0;$i<=$occurances;$i++)
		{
			$dice_seed = mt_rand();
			$text = preg_replace("#\[dice\]([-\s\w+/*]*?)\[/dice\]#i", "[dice:$uid]\\1 = $dice_seed [/dice:$uid] $limit", $text, 1);
			$dice_seed = mt_rand();
			$text = preg_replace("#\[dice=(\\\\\".*?\\\\\")\]([-\s\w+/*]*?)\[/dice\]#i", "[dice:$uid=\\1]\\2 = $dice_seed [/dice:$uid] $limit", $text, 1);
		}
		$text = preg_replace("#\[dice\]([-\s\w+/*]*?)=([\s\d]*?)\[/dice\]#i", "[dice:$uid]\\1 = \\2 = Fixed[/dice:$uid]", $text);
		$text = preg_replace("#\[dice\]([-\s\w+/*]*?)=([\s\d]*?)=\s*?Fixed\s*?\[/dice\]#i", "[dice:$uid]\\1 = \\2 = Fixed[/dice:$uid]", $text);
		$text = preg_replace("#\[dice=(\\\\\".*?\\\\\")\]([-\s\w+/*]*?)=([\s\d]*?)\[/dice\]#i", "[dice:$uid=\\1]\\2 = \\3 = Fixed[/dice:$uid]", $text);
		$text = preg_replace("#\[dice=(\\\\\".*?\\\\\")\]([-\s\w+/*]*?)=([\s\d]*?)=\s*?Fixed\s*?\[/dice\]#i", "[dice:$uid=\\1]\\2 = \\3 = Fixed[/dice:$uid]", $text);
		// --------------------------------
		// END DICE MOD CODE
		// --------------------------------
	}
}

class dice_mod_faq extends plug_ins
{
	function get(&$mode)
	{

		global $config, $user, $faq;
		if ( $mode == 'bbcode' )
		{
			if (@file_exists(phpbb_realpath($config->url('language/lang_' . $user->lang_used . '/lang_faq_dice_bbcode'))) )
			{
				include($config->url('language/lang_' . $user->lang_used . '/lang_faq_dice_bbcode'));
			}
		}
	}
}
// intantiate: this is our plug-ins definition
$config->set_plug_ins('mod_dice_bbcode_CH', array(
'bbcode' => array(
'layer' => '',
'object' => 'dice_bbcode',
),
'faq' => array(
'layer' => '',
'object' => 'dice_mod_faq',
),
));

?>